## ros-eloquent-swri-transform-util 3.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(swri_transform_util)

set(CMAKE_CXX_STANDARD 14)

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)
find_package(diagnostic_msgs REQUIRED)
find_package(geographic_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(gps_msgs REQUIRED)
find_package(marti_nav_msgs REQUIRED)
find_package(rcl_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(swri_math_util REQUIRED)
find_package(swri_roscpp REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_ros REQUIRED)

# tf2_geometry_msgs 0.12.1 broke API compatibility, so check which version
# we need to use
find_package(tf2_geometry_msgs REQUIRED)
if("${tf2_geometry_msgs_VERSION}" VERSION_GREATER "0.12.0")
  set(USE_NEW_TF2_TOMSG 1)
else()
  set(USE_NEW_TF2_TOMSG 0)
endif()

find_package(yaml-cpp REQUIRED)
find_package(OpenCV REQUIRED calib3d core highgui imgproc video)
find_package(Boost REQUIRED thread)

find_package(PkgConfig REQUIRED)
pkg_check_modules(PROJ proj)
if(NOT "${PROJ_FOUND}")
  set(PROJ_INCLUDE_DIRS /usr/include)
  set(PROJ_LIBRARY_DIRS /usr/lib)
  find_library(PROJ_LIBRARIES proj
    HINTS ${PROJ_LIB_DIRS}
  )
endif()

add_library(${PROJECT_NAME}
  src/georeference.cpp
  src/local_xy_util.cpp
  src/utm_util.cpp
  src/transform.cpp
  src/transformer.cpp
  src/transform_manager.cpp
  src/transform_util.cpp
  src/utm_transformer.cpp
  src/wgs84_transformer.cpp)
target_include_directories(${PROJECT_NAME}
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
target_include_directories(${PROJECT_NAME}
  SYSTEM
  INTERFACE
  ${PROJ_INCLUDE_DIRS}
)
set_property(TARGET ${PROJECT_NAME}
  PROPERTY POSITION_INDEPENDENT_CODE ON)
target_compile_definitions(${PROJECT_NAME}
  PRIVATE
    USE_NEW_TF2_TOMSG=${USE_NEW_TF2_TOMSG}
)
target_compile_definitions(${PROJECT_NAME} PUBLIC "-DACCEPT_USE_OF_DEPRECATED_PROJ_API_H")
target_link_libraries(${PROJECT_NAME}
  Boost::boost
  Boost::thread
  opencv_calib3d
  opencv_core
  opencv_highgui
  opencv_imgproc
  opencv_video
  ${PROJ_LIBRARIES}
  yaml-cpp
)
ament_target_dependencies(${PROJECT_NAME}
  diagnostic_msgs
  geographic_msgs
  geometry_msgs
  gps_msgs
  rclcpp
  sensor_msgs
  swri_math_util
  swri_roscpp
  tf2
  tf2_geometry_msgs
  tf2_ros
)

add_library(${PROJECT_NAME}_nodes SHARED
  src/nodes/dynamic_transform_publisher.cpp
  src/nodes/gps_transform_publisher.cpp
  src/nodes/obstacle_transformer.cpp
)
target_include_directories(${PROJECT_NAME}_nodes
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
target_include_directories(${PROJECT_NAME}_nodes
  SYSTEM
  INTERFACE
  ${PROJ_INCLUDE_DIRS}
)
target_compile_definitions(${PROJECT_NAME}_nodes
  PRIVATE "COMPOSITION_BUILDING_DLL")
rclcpp_components_register_nodes(${PROJECT_NAME}_nodes "swri_transform_util::DynamicTransformPublisher")
rclcpp_components_register_nodes(${PROJECT_NAME}_nodes "swri_transform_util::GpsTransformPublisher")
rclcpp_components_register_nodes(${PROJECT_NAME}_nodes "swri_transform_util::ObstacleTransformer")
target_link_libraries(${PROJECT_NAME}_nodes ${PROJECT_NAME})
ament_target_dependencies(${PROJECT_NAME}_nodes
  marti_nav_msgs
  rcl_interfaces
)

add_executable(lat_lon_tf_echo src/nodes/lat_lon_tf_echo.cpp)
target_include_directories(lat_lon_tf_echo
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
target_include_directories(lat_lon_tf_echo
  SYSTEM
  INTERFACE
  ${PROJ_INCLUDE_DIRS}
)
target_link_libraries(lat_lon_tf_echo ${PROJECT_NAME})

# TODO pjr Convert unit tests
# if(BUILD_TESTING)
#   find_package(ament_cmake_gtest REQUIRED)
# 
#  add_rostest_gtest(test_local_xy_util launch/local_xy_util.test test/test_local_xy_util.cpp)
#  target_link_libraries(test_local_xy_util ${PROJECT_NAME})
#
#  add_rostest_gtest(test_utm_util launch/utm_util.test test/test_utm_util.cpp)
#  target_link_libraries(test_utm_util ${PROJECT_NAME})
#
#  add_rostest_gtest(test_transform_manager launch/transform_manager.test test/test_transform_manager.cpp)
#  target_link_libraries(test_transform_manager ${PROJECT_NAME})
#
#  add_rostest_gtest(test_georeference launch/georeference.test test/test_georeference.cpp)
#  target_link_libraries(test_georeference ${PROJECT_NAME})
#
#  add_rostest_gtest(test_transform_util launch/transform_util.test test/test_transform_util.cpp)
#  target_link_libraries(test_transform_util ${PROJECT_NAME})
#
#  add_rostest(test/initialize_invalid_gps.test)
#  add_rostest(test/initialize_invalid_navsat.test)
#  add_rostest(test/initialize_origin_auto_custom.test)
#  add_rostest(test/initialize_origin_auto_gps.test)
#  add_rostest(test/initialize_origin_auto_navsat.test)
#  add_rostest(test/initialize_origin_manual.test)
# endif()

install(DIRECTORY include/
  DESTINATION include
)

install(DIRECTORY launch
  DESTINATION share/${PROJECT_NAME}/
)

install(TARGETS
  ${PROJECT_NAME}
  ${PROJECT_NAME}_nodes
  lat_lon_tf_echo
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

### Install Python Nodes/Scripts ###
install(PROGRAMS nodes/initialize_origin.py
  DESTINATION lib/${PROJECT_NAME}
)

ament_python_install_package(${PROJECT_NAME})

ament_export_dependencies(
  ament_cmake
  geographic_msgs
  gps_msgs
)
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME}
  ${PROJ_LIBRARIES}
)

ament_package()

=== debian/changelog ===
ros-eloquent-swri-transform-util (3.3.2-1bionic) bionic; urgency=high



 -- P. J. Reed <preed@swri.org>  Tue, 24 Nov 2020 06:00:00 -0000

ros-eloquent-swri-transform-util (3.3.1-1bionic) bionic; urgency=high

  * Fix bad conversion when 90 degree yaw specified (#599 <https://github.com/swri-robotics/marti_common/issues/599>)
  * Contributors: Alex Youngs

 -- P. J. Reed <preed@swri.org>  Wed, 19 Aug 2020 05:00:00 -0000

ros-eloquent-swri-transform-util (3.3.0-1bionic) bionic; urgency=high

  * Add python wgs84 transformer ros2 (#596 <https://github.com/swri-robotics/marti_common/issues/596>)
  * Improve object transformer to take into account the pose of the object (#589 <https://github.com/swri-robotics/marti_common/issues/589>) (#591 <https://github.com/swri-robotics/marti_common/issues/591>)
  * Add GitHub Actions for CI (ROS2) (#586 <https://github.com/swri-robotics/marti_common/issues/586>)
  * Contributors: P. J. Reed, Alex Youngs, Matthew Bries

 -- P. J. Reed <preed@swri.org>  Wed, 15 Jul 2020 05:00:00 -0000

ros-eloquent-swri-transform-util (3.2.1-1bionic) bionic; urgency=high

  * ROS Foxy support (#582 <https://github.com/swri-robotics/marti_common/issues/582>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Wed, 10 Jun 2020 05:00:00 -0000

ros-eloquent-swri-transform-util (3.2.0-1bionic) bionic; urgency=high



 -- P. J. Reed <preed@swri.org>  Wed, 13 May 2020 05:00:00 -0000

ros-eloquent-swri-transform-util (3.1.0-1bionic) bionic; urgency=high

  * Fix swri_transform_util::TransformManager initialization issues
  * Implement initialize_origin.py in ROS Eloquent
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Mon, 30 Mar 2020 05:00:00 -0000

ros-eloquent-swri-transform-util (3.0.5-1bionic) bionic; urgency=high

  * Also add NavSatFix support to swri_transform_util::LocalXyUtil (#569 <https://github.com/swri-robotics/marti_common/issues/569>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Tue, 10 Mar 2020 05:00:00 -0000

ros-eloquent-swri-transform-util (3.0.4-1bionic) bionic; urgency=high

  * ROS 2 Eloquent compatibility (#568 <https://github.com/swri-robotics/marti_common/issues/568>)
  * Replace boost::array with std::array (#567 <https://github.com/swri-robotics/marti_common/issues/567>)
  * Fix a crash that happened due to an initialization error (#566 <https://github.com/swri-robotics/marti_common/issues/566>)
  * Fix TransformManager so it works in ROS2 (#565 <https://github.com/swri-robotics/marti_common/issues/565>)
  * Port ObstacleTransformer node to ROS2 (#559 <https://github.com/swri-robotics/marti_common/issues/559>)
  * Remove "nodelets" directory (#558 <https://github.com/swri-robotics/marti_common/issues/558>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Thu, 05 Mar 2020 06:00:00 -0000

ros-eloquent-swri-transform-util (3.0.3-1bionic) bionic; urgency=high



 -- P. J. Reed <preed@swri.org>  Mon, 11 Nov 2019 06:00:00 -0000

ros-eloquent-swri-transform-util (3.0.2-1bionic) bionic; urgency=high

  * Comment out ament_cmake_gtest (#555 <https://github.com/pjreed/marti_common/issues/555>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Mon, 11 Nov 2019 06:00:00 -0000

ros-eloquent-swri-transform-util (3.0.1-1bionic) bionic; urgency=high

  * Add missing dependency on Boost::thread to swri_transform_util (#554 <https://github.com/pjreed/marti_common/issues/554>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Mon, 11 Nov 2019 06:00:00 -0000

ros-eloquent-swri-transform-util (3.0.0-1bionic) bionic; urgency=high

  * ROS2 Dashing conversion (#549 <https://github.com/pjreed/marti_common/issues/549>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Fri, 08 Nov 2019 06:00:00 -0000

ros-eloquent-swri-transform-util (2.10.0-1bionic) bionic; urgency=high

  * Support in initialize_origin.py specifying custom ROS topic in parameter (#544 <https://github.com/swri-robotics/marti_common/issues/544>)
  * Fix get relative transform (#546 <https://github.com/swri-robotics/marti_common/issues/546>)
  * Contributors: Arkady Shapkin, Matthew

 -- P. J. Reed <preed@swri.org>  Wed, 04 Sep 2019 05:00:00 -0000

ros-eloquent-swri-transform-util (2.9.0-1bionic) bionic; urgency=high



 -- P. J. Reed <preed@swri.org>  Thu, 23 May 2019 05:00:00 -0000

ros-eloquent-swri-transform-util (2.8.0-1bionic) bionic; urgency=high

  * Reduce the number of local_xy subscribers from 3 per transform manager to 1 (#537 <https://github.com/swri-robotics/marti_common/issues/537>)
  * Add dynamic parameters (#532 <https://github.com/swri-robotics/marti_common/issues/532>)
  * Contributors: Matthew

 -- P. J. Reed <preed@swri.org>  Wed, 06 Feb 2019 06:00:00 -0000

ros-eloquent-swri-transform-util (2.7.3-1bionic) bionic; urgency=high



 -- P. J. Reed <preed@swri.org>  Thu, 03 Jan 2019 06:00:00 -0000

ros-eloquent-swri-transform-util (2.7.2-1bionic) bionic; urgency=high

  * Fix the unit test that intermittently breaks (#534 <https://github.com/swri-robotics/marti_common/issues/534>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Thu, 20 Dec 2018 06:00:00 -0000

ros-eloquent-swri-transform-util (2.7.1-1bionic) bionic; urgency=high



 -- P. J. Reed <preed@swri.org>  Fri, 14 Dec 2018 06:00:00 -0000

ros-eloquent-swri-transform-util (2.7.0-1bionic) bionic; urgency=high



 -- P. J. Reed <preed@swri.org>  Tue, 04 Dec 2018 06:00:00 -0000

ros-eloquent-swri-transform-util (2.6.0-1bionic) bionic; urgency=high



 -- P. J. Reed <preed@swri.org>  Sat, 03 Nov 2018 05:00:00 -0000

ros-eloquent-swri-transform-util (2.5.0-1bionic) bionic; urgency=high



 -- P. J. Reed <preed@swri.org>  Fri, 12 Oct 2018 05:00:00 -0000

ros-eloquent-swri-transform-util (2.4.0-1bionic) bionic; urgency=high

  * Handle invalid fixes properly (#519 <https://github.com/swri-robotics/marti_common/issues/519>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Tue, 09 Oct 2018 05:00:00 -0000



=== debian/control ===
Source: ros-eloquent-swri-transform-util
Section: misc
Priority: optional
Maintainer: P. J. Reed <preed@swri.org>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libgeos++-dev, libproj-dev, libyaml-cpp-dev, pkg-config, ros-eloquent-ament-cmake, ros-eloquent-ament-cmake-python, ros-eloquent-cv-bridge, ros-eloquent-diagnostic-msgs, ros-eloquent-geographic-msgs, ros-eloquent-geometry-msgs, ros-eloquent-gps-msgs, ros-eloquent-marti-nav-msgs, ros-eloquent-rcl-interfaces, ros-eloquent-rclcpp, ros-eloquent-rclcpp-components, ros-eloquent-rclpy, ros-eloquent-sensor-msgs, ros-eloquent-swri-math-util, ros-eloquent-swri-roscpp, ros-eloquent-tf2, ros-eloquent-tf2-geometry-msgs, ros-eloquent-tf2-ros, ros-eloquent-ros-workspace
Homepage: https://github.com/swri-robotics/marti_common
Standards-Version: 3.9.2

Package: ros-eloquent-swri-transform-util
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libgeos++-dev, libproj-dev, libyaml-cpp-dev, python3-numpy, ros-eloquent-cv-bridge, ros-eloquent-diagnostic-msgs, ros-eloquent-geographic-msgs, ros-eloquent-geometry-msgs, ros-eloquent-gps-msgs, ros-eloquent-launch-xml, ros-eloquent-marti-nav-msgs, ros-eloquent-rcl-interfaces, ros-eloquent-rclcpp, ros-eloquent-rclcpp-components, ros-eloquent-rclpy, ros-eloquent-sensor-msgs, ros-eloquent-swri-math-util, ros-eloquent-swri-roscpp, ros-eloquent-tf2, ros-eloquent-tf2-geometry-msgs, ros-eloquent-tf2-py, ros-eloquent-tf2-ros, ros-eloquent-ros-workspace
Description: The swri_transform_util package contains utility functions and classes for transforming between coordinate frames.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/eloquent/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/eloquent" \
		-DAMENT_PREFIX_PATH="/opt/ros/eloquent" \
		-DCMAKE_PREFIX_PATH="/opt/ros/eloquent"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-eloquent-swri-transform-util//opt/ros/eloquent/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_install
